/********************************************************************************/
/*										*/
/*			     				*/
/*			     Written by Ken Goldman				*/
/*		       IBM Thomas J. Watson Research Center			*/
/*            $Id: StartAuthSession_fp.h 683 2016-07-15 20:53:46Z kgoldman $	*/
/*										*/
/*  Licenses and Notices							*/
/*										*/
/*  1. Copyright Licenses:							*/
/*										*/
/*  - Trusted Computing Group (TCG) grants to the user of the source code in	*/
/*    this specification (the "Source Code") a worldwide, irrevocable, 		*/
/*    nonexclusive, royalty free, copyright license to reproduce, create 	*/
/*    derivative works, distribute, display and perform the Source Code and	*/
/*    derivative works thereof, and to grant others the rights granted herein.	*/
/*										*/
/*  - The TCG grants to the user of the other parts of the specification 	*/
/*    (other than the Source Code) the rights to reproduce, distribute, 	*/
/*    display, and perform the specification solely for the purpose of 		*/
/*    developing products based on such documents.				*/
/*										*/
/*  2. Source Code Distribution Conditions:					*/
/*										*/
/*  - Redistributions of Source Code must retain the above copyright licenses, 	*/
/*    this list of conditions and the following disclaimers.			*/
/*										*/
/*  - Redistributions in binary form must reproduce the above copyright 	*/
/*    licenses, this list of conditions	and the following disclaimers in the 	*/
/*    documentation and/or other materials provided with the distribution.	*/
/*										*/
/*  3. Disclaimers:								*/
/*										*/
/*  - THE COPYRIGHT LICENSES SET FORTH ABOVE DO NOT REPRESENT ANY FORM OF	*/
/*  LICENSE OR WAIVER, EXPRESS OR IMPLIED, BY ESTOPPEL OR OTHERWISE, WITH	*/
/*  RESPECT TO PATENT RIGHTS HELD BY TCG MEMBERS (OR OTHER THIRD PARTIES)	*/
/*  THAT MAY BE NECESSARY TO IMPLEMENT THIS SPECIFICATION OR OTHERWISE.		*/
/*  Contact TCG Administration (admin@trustedcomputinggroup.org) for 		*/
/*  information on specification licensing rights available through TCG 	*/
/*  membership agreements.							*/
/*										*/
/*  - THIS SPECIFICATION IS PROVIDED "AS IS" WITH NO EXPRESS OR IMPLIED 	*/
/*    WARRANTIES WHATSOEVER, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR 	*/
/*    FITNESS FOR A PARTICULAR PURPOSE, ACCURACY, COMPLETENESS, OR 		*/
/*    NONINFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS, OR ANY WARRANTY 		*/
/*    OTHERWISE ARISING OUT OF ANY PROPOSAL, SPECIFICATION OR SAMPLE.		*/
/*										*/
/*  - Without limitation, TCG and its members and licensors disclaim all 	*/
/*    liability, including liability for infringement of any proprietary 	*/
/*    rights, relating to use of information in this specification and to the	*/
/*    implementation of this specification, and TCG disclaims all liability for	*/
/*    cost of procurement of substitute goods or services, lost profits, loss 	*/
/*    of use, loss of data or any incidental, consequential, direct, indirect, 	*/
/*    or special damages, whether under contract, tort, warranty or otherwise, 	*/
/*    arising in any way out of use or reliance upon this specification or any 	*/
/*    information herein.							*/
/*										*/
/*  (c) Copyright IBM Corp. and others, 2012-2015				*/
/*										*/
/********************************************************************************/

/* rev 119 */

#ifndef STARTAUTHSESSION_FP_H
#define STARTAUTHSESSION_FP_H

typedef struct {
    TPMI_DH_OBJECT		tpmKey;
    TPMI_DH_ENTITY		bind;
    TPM2B_NONCE			nonceCaller;
    TPM2B_ENCRYPTED_SECRET	encryptedSalt;
    TPM_SE			sessionType;
    TPMT_SYM_DEF		symmetric;
    TPMI_ALG_HASH		authHash;
} StartAuthSession_In;

typedef struct {
    TPMI_SH_AUTH_SESSION	sessionHandle;
    TPM2B_NONCE			nonceTPM;
} StartAuthSession_Out;  

#define RC_StartAuthSession_tpmKey 		(TPM_RC_H + TPM_RC_1)
#define RC_StartAuthSession_bind 		(TPM_RC_H + TPM_RC_2)
#define RC_StartAuthSession_nonceCaller 	(TPM_RC_P + TPM_RC_1)
#define RC_StartAuthSession_encryptedSalt 	(TPM_RC_P + TPM_RC_2)
#define RC_StartAuthSession_sessionType 	(TPM_RC_P + TPM_RC_3)
#define RC_StartAuthSession_symmetric 		(TPM_RC_P + TPM_RC_4)
#define RC_StartAuthSession_authHash 		(TPM_RC_P + TPM_RC_5)

TPM_RC
TPM2_StartAuthSession(
		      StartAuthSession_In     *in,            // IN: input parameter buffer
		      StartAuthSession_Out    *out            // OUT: output parameter buffer
		      );


#endif
